
    volScalarField& he = thermo.he();

    fvScalarMatrix EEqn
    (
        fvm::ddt(rho, he) + fvm::div(phi, he)
      + fvc::ddt(rho, K) + fvc::div(phi, K)
      + (
            he.name() == "e"
          ? fvc::div
            (
                fvc::absolute(phi/fvc::interpolate(rho), U),
                p,
                "div(phiv,p)"
            )
          : -dpdt
        )
      - fvm::laplacian(turbulence->alphaEff(), he)
     ==
        rho*(U&g)
      - L*(fvc::ddt(rho, gl))
      //+ radiation->Sh(thermo, he)
      + fvOptions(rho, he)
    );

    EEqn.relax();

    fvOptions.constrain(EEqn);

    EEqn.solve();

    fvOptions.correct(he);

    thermo.correct();
    //radiation->correct();

    volScalarField glNew = gl + glRelax*(thermo.T()-Tmelt)*thermo.Cp()/L;
    //gl = max(scalar(0), min(glNew, scalar(1)));
	volScalarField x=(thermo.T()-Tmelt+delT)/(2*delT);
	gl=1.0*Foam::pos(thermo.T()-Tmelt-delT) + x * Foam::pos(x) * Foam::pos(Tmelt+delT-thermo.T()) ;

    Cp = thermo.Cp();
